﻿using System;
using System.Diagnostics;

namespace Tscharlii
{
    public class Hydrophone
    {
        private const string LOG_PREFIX = "Tscharlii::Hydrophone";

        private const string SHControllersmoduleName = "SHControllers.act";

        // SHControllers+0x2CA67  fld   dword ptr [esi+8C]
        // SHControllers+0x2CA6D  jmp   SHControllers+0x2CA75
        private const uint codeCave1_Address = 0x0002CA67;
        private byte[] codeCave1             = new byte[] { 0xD9, 0x86, 0x8C, 0x00, 0x00, 0x00,
                                                            0xEB, 0x06 };


        // SHControllers+0x2CA75  mov   dword ptr [SHControllers+0x2CB62], ecx     ; Note: the SHControllers Imagebase needs to be calculated dynamically, see patchGetHydroRotateToVarLocation below
        // SHControllers+0x2CA7B  jmp   SHControllers+0x2CAC1
        private const uint codeCave2_Address = 0x0002CA75;
        private byte[] codeCave2             = new byte[] { 0x89, 0x0D, 0x00, 0x00, 0x00, 0x00,
                                                            0xEB, 0x44 };

        private const uint dataCave_Address  = 0x0002CB62;
        private uint relocated_DataCave_Address;

        // SHControllers+0x2CABB  jmp   SHControllers+0x2CA67
        private const uint hook_Address      = 0x0002CABB;
        private byte[] hook                  = new byte[] { 0xEB, 0xAA,
                                                            0x90, 0x90, 0x90, 0x90 };

        ProcessMemory processMemory;

        public Hydrophone()
        {
            processMemory = new ProcessMemory("SHControllers.act");
            patchGetHydroRotateToVarLocation();
        }

        ~Hydrophone()
        {
        }

        private void patchGetHydroRotateToVarLocation()
        {
            // relocate the datacave address in codecave 2
            relocated_DataCave_Address = processMemory.getImageBase() + dataCave_Address;
            byte[] injectAddressIntoOpCode = BitConverter.GetBytes(relocated_DataCave_Address);
            for (int i = 0; i < 4; i++)
            {
                codeCave2[i + 2] = injectAddressIntoOpCode[i];
            }

            // patch sh5: enablewriteaccess to datacave; write codecave1, codecave2 and hook 
            processMemory.EnableWriteAccessTo(dataCave_Address, sizeof(uint));
            processMemory.WriteMem(codeCave1_Address, codeCave1);
            processMemory.WriteMem(codeCave2_Address, codeCave2);
            processMemory.WriteMem(hook_Address, hook); 
        }

        public void setBearing(float newHydroBearing)
        {
            //*(float*)((uint)GuiDialsWrapper.DialTypes.HYDROPHONE * (uint)GuiDialsWrapper.DialTypes.THROTTLE + (uint)guiDials.pRefTarget + 176) = value;

            const uint BASE_ADDRESS_NOT_SET = 0xCCCCCCCC;
            const uint BASE_ADDRESS_NULL = 0x00000000;
            const uint SET_HYDRO_BEARING_OFFSET = 0x8C;

            byte[] baseAddressBytes = new byte[sizeof(uint)];
            if (processMemory.ReadMem(dataCave_Address, baseAddressBytes))
            {
                uint baseAddress = BitConverter.ToUInt32(baseAddressBytes, 0);
                if ((baseAddress != BASE_ADDRESS_NOT_SET) & (baseAddress != BASE_ADDRESS_NULL))
                {
                    uint setHydrophoneBearingAddress = baseAddress + SET_HYDRO_BEARING_OFFSET;
                    byte[] newHydroBearingBytes = BitConverter.GetBytes(newHydroBearing);
                    if (! processMemory.WriteMem(setHydrophoneBearingAddress, newHydroBearingBytes, false))
                    {
                        Trace.WriteLine(LOG_PREFIX + "::setBearing: failed to set Hydrophone Bearing. Unable to write to setHydrophoneBearingAddress");
                    }
                }
                else
                {
                    Trace.WriteLine(LOG_PREFIX + "::setBearing: failed to set Hydrophone Bearing. HydroRotateToVarLocation has not been set.");
                }
            }
            else
            {
                Trace.WriteLine(LOG_PREFIX + "::setBearing: failed to set Hydrophone Bearing. Unable to read HydroRotateToVarLocation.");
            }
        }
    }
}
